diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/sta-wifi-mac.cc ns-3.39/src/wifi/model/sta-wifi-mac.cc
--- ns-3.38/src/wifi/model/sta-wifi-mac.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/sta-wifi-mac.cc	2023-07-05 14:23:48.121428500 -0700
@@ -1368,20 +1564,131 @@
             return;
         }
         /* EHT station */
-        const auto& ehtCapabilities = frame.GetEhtCapabilities();
+        const auto& ehtCapabilities = frame.template Get<EhtCapabilities>();
         // TODO: once we support non constant rate managers, we should add checks here whether EHT
         // is supported by the peer
         GetWifiRemoteStationManager(linkId)->AddStationEhtCapabilities(apAddr, *ehtCapabilities);
+
+        if (const auto& mle = frame.template Get<MultiLinkElement>();
+            mle && mle->HasEmlCapabilities() && m_emlsrManager)
+        {
+            m_emlsrManager->SetTransitionTimeout(mle->GetTransitionTimeout());
+        }
     };
 
     // process Information Elements included in the current frame variant
     std::visit(commonOps, frame);
 }
 
-SupportedRates
+void
+StaWifiMac::SetPowerSaveMode(const std::pair<bool, uint8_t>& enableLinkIdPair)
+{
+    const auto [enable, linkId] = enableLinkIdPair;
+    NS_LOG_FUNCTION(this << enable << linkId);
+
+    auto& link = GetLink(linkId);
+
+    if (!IsAssociated())
+    {
+        NS_LOG_DEBUG("Not associated yet, record the PM mode to switch to upon association");
+        link.pmMode = enable ? WIFI_PM_POWERSAVE : WIFI_PM_ACTIVE;
+        return;
+    }
+
+    if (!link.bssid)
+    {
+        NS_LOG_DEBUG("Link " << +linkId << " has not been setup, ignore request");
+        return;
+    }
+
+    if ((enable && link.pmMode == WIFI_PM_POWERSAVE) || (!enable && link.pmMode == WIFI_PM_ACTIVE))
+    {
+        NS_LOG_DEBUG("No PM mode change needed");
+        return;
+    }
+
+    link.pmMode = enable ? WIFI_PM_SWITCHING_TO_PS : WIFI_PM_SWITCHING_TO_ACTIVE;
+
+    // reschedule a call to this function to make sure that the PM mode switch
+    // is eventually completed
+    Simulator::Schedule(m_pmModeSwitchTimeout,
+                        &StaWifiMac::SetPowerSaveMode,
+                        this,
+                        enableLinkIdPair);
+
+    if (HasFramesToTransmit(linkId))
+    {
+        NS_LOG_DEBUG("Next transmitted frame will be sent with PM=" << enable);
+        return;
+    }
+
+    // No queued frames. Enqueue a Data Null frame to inform the AP of the PM mode change
+    WifiMacHeader hdr(WIFI_MAC_DATA_NULL);
+
+    hdr.SetAddr1(GetBssid(linkId));
+    hdr.SetAddr2(GetFrameExchangeManager(linkId)->GetAddress());
+    hdr.SetAddr3(GetBssid(linkId));
+    hdr.SetDsNotFrom();
+    hdr.SetDsTo();
+    enable ? hdr.SetPowerManagement() : hdr.SetNoPowerManagement();
+    if (GetQosSupported())
+    {
+        GetQosTxop(AC_BE)->Queue(Create<WifiMpdu>(Create<Packet>(), hdr));
+    }
+    else
+    {
+        m_txop->Queue(Create<WifiMpdu>(Create<Packet>(), hdr));
+    }
+}
+
+WifiPowerManagementMode
+StaWifiMac::GetPmMode(uint8_t linkId) const
+{
+    return GetLink(linkId).pmMode;
+}
+
+void
+StaWifiMac::TxOk(Ptr<const WifiMpdu> mpdu)
+{
+    NS_LOG_FUNCTION(this << *mpdu);
+
+    auto linkId = GetLinkIdByAddress(mpdu->GetHeader().GetAddr2());
+
+    if (!linkId)
+    {
+        // the given MPDU may be the original copy containing MLD addresses and not carrying
+        // a valid PM bit (which is set on the aliases).
+        auto linkIds = mpdu->GetInFlightLinkIds();
+        NS_ASSERT_MSG(!linkIds.empty(),
+                      "The TA of the acked MPDU (" << *mpdu
+                                                   << ") is not a link "
+                                                      "address and the MPDU is not inflight");
+        // in case the ack'ed MPDU is inflight on multiple links, we cannot really know if
+        // it was received by the AP on all links or only on some links. Hence, we only
+        // consider the first link ID in the set, given that in the most common case of MPDUs
+        // that cannot be sent concurrently on multiple links, there will be only one link ID
+        linkId = *linkIds.begin();
+        mpdu = GetTxopQueue(mpdu->GetQueueAc())->GetAlias(mpdu, *linkId);
+    }
+
+    auto& link = GetLink(*linkId);
+    const WifiMacHeader& hdr = mpdu->GetHeader();
+
+    // we received an acknowledgment while switching PM mode; the PM mode change is effective now
+    if (hdr.IsPowerManagement() && link.pmMode == WIFI_PM_SWITCHING_TO_PS)
+    {
+        link.pmMode = WIFI_PM_POWERSAVE;
+    }
+    else if (!hdr.IsPowerManagement() && link.pmMode == WIFI_PM_SWITCHING_TO_ACTIVE)
+    {
+        link.pmMode = WIFI_PM_ACTIVE;
+    }
+}
+
+AllSupportedRates
 StaWifiMac::GetSupportedRates(uint8_t linkId) const
 {
-    SupportedRates rates;
+    AllSupportedRates rates;
     for (const auto& mode : GetWifiPhy(linkId)->GetModeList())
     {
         uint64_t modeDataRate = mode.GetDataRate(GetWifiPhy(linkId)->GetChannelWidth());
@@ -1415,31 +1722,23 @@
 }
 
 void
-StaWifiMac::SetEdcaParameters(AcIndex ac,
-                              uint32_t cwMin,
-                              uint32_t cwMax,
-                              uint8_t aifsn,
-                              Time txopLimit)
-{
-    Ptr<QosTxop> edca = GetQosTxop(ac);
-    edca->SetMinCw(cwMin, SINGLE_LINK_OP_ID);
-    edca->SetMaxCw(cwMax, SINGLE_LINK_OP_ID);
-    edca->SetAifsn(aifsn, SINGLE_LINK_OP_ID);
-    edca->SetTxopLimit(txopLimit, SINGLE_LINK_OP_ID);
+StaWifiMac::SetEdcaParameters(const EdcaParams& params, uint8_t linkId)
+{
+    Ptr<QosTxop> edca = GetQosTxop(params.ac);
+    edca->SetMinCw(params.cwMin, linkId);
+    edca->SetMaxCw(params.cwMax, linkId);
+    edca->SetAifsn(params.aifsn, linkId);
+    edca->SetTxopLimit(params.txopLimit, linkId);
 }
 
 void
-StaWifiMac::SetMuEdcaParameters(AcIndex ac,
-                                uint16_t cwMin,
-                                uint16_t cwMax,
-                                uint8_t aifsn,
-                                Time muEdcaTimer)
-{
-    Ptr<QosTxop> edca = GetQosTxop(ac);
-    edca->SetMuCwMin(cwMin, SINGLE_LINK_OP_ID);
-    edca->SetMuCwMax(cwMax, SINGLE_LINK_OP_ID);
-    edca->SetMuAifsn(aifsn, SINGLE_LINK_OP_ID);
-    edca->SetMuEdcaTimer(muEdcaTimer, SINGLE_LINK_OP_ID);
+StaWifiMac::SetMuEdcaParameters(const MuEdcaParams& params, uint8_t linkId)
+{
+    Ptr<QosTxop> edca = GetQosTxop(params.ac);
+    edca->SetMuCwMin(params.cwMin, linkId);
+    edca->SetMuCwMax(params.cwMax, linkId);
+    edca->SetMuAifsn(params.aifsn, linkId);
+    edca->SetMuEdcaTimer(params.muEdcaTimer, linkId);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/sta-wifi-mac.h ns-3.39/src/wifi/model/sta-wifi-mac.h
--- ns-3.38/src/wifi/model/sta-wifi-mac.h	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/sta-wifi-mac.h	2023-07-05 14:23:48.121428500 -0700
@@ -40,6 +40,18 @@
 class CapabilityInformation;
 class RandomVariableStream;
 class WifiAssocManager;
+class EmlsrManager;
+
+/**
+ * \ingroup wifi
+ *
+ * Scan type (active or passive)
+ */
+enum class WifiScanType : uint8_t
+{
+    ACTIVE = 0,
+    PASSIVE
+};
 
 /**
  * \ingroup wifi
@@ -63,12 +75,7 @@
     /// typedef for a list of channels
     using ChannelList = std::list<Channel>;
 
-    enum : uint8_t
-    {
-        ACTIVE = 0,
-        PASSIVE
-    } type; ///< indicates either active or passive scanning
-
+    WifiScanType type;                    ///< indicates either active or passive scanning
     Ssid ssid;                            ///< desired SSID or wildcard SSID
     std::vector<ChannelList> channelList; ///< list of channels to scan, for each link
     Time probeDelay;                      ///< delay prior to transmitting a Probe Request
@@ -79,6 +86,19 @@
 /**
  * \ingroup wifi
  *
+ * Enumeration for power management modes
+ */
+enum WifiPowerManagementMode : uint8_t
+{
+    WIFI_PM_ACTIVE = 0,
+    WIFI_PM_SWITCHING_TO_PS,
+    WIFI_PM_POWERSAVE,
+    WIFI_PM_SWITCHING_TO_ACTIVE
+};
+
+/**
+ * \ingroup wifi
+ *
  * The Wifi MAC high model for a non-AP STA in a BSS. The state
  * machine is as follows:
  *
@@ -149,7 +169,7 @@
         WifiScanParams::Channel m_channel; ///< The channel the management frame was received on
         uint8_t m_linkId;                  ///< ID of the link used to communicate with the AP
         /// list of (local link ID, AP link ID) pairs identifying the links to setup between MLDs
-        std::list<std::pair<std::uint8_t, uint8_t>> m_setupLinks;
+        std::list<std::pair<uint8_t, uint8_t>> m_setupLinks;
     };
 
     /**
@@ -185,10 +205,23 @@
     void SetAssocManager(Ptr<WifiAssocManager> assocManager);
 
     /**
-     * Forward a probe request packet to the DCF. The standard is not clear on the correct
-     * queue for management frames if QoS is supported. We always use the DCF.
+     * Set the EMLSR Manager.
+     *
+     * \param emlsrManager the EMLSR Manager
+     */
+    void SetEmlsrManager(Ptr<EmlsrManager> emlsrManager);
+
+    /**
+     * \return the EMLSR Manager
+     */
+    Ptr<EmlsrManager> GetEmlsrManager() const;
+
+    /**
+     * Enqueue a probe request packet for transmission on the given link.
+     *
+     * \param linkId the ID of the given link
      */
-    void SendProbeRequest();
+    void SendProbeRequest(uint8_t linkId);
 
     /**
      * This method is called after wait beacon timeout or wait probe request timeout has
@@ -214,12 +247,47 @@
     std::set<uint8_t> GetSetupLinkIds() const;
 
     /**
+     * \param linkId the IO of the given link
+     * \return the ID (as set by the AP) of the given link, if the given link has been setup
+     */
+    std::optional<uint8_t> GetApLinkId(uint8_t linkId) const;
+
+    /**
      * Return the association ID.
      *
      * \return the association ID
      */
     uint16_t GetAssociationId() const;
 
+    /**
+     * Enable or disable Power Save mode on the given link.
+     *
+     * \param enableLinkIdPair a pair indicating whether to enable or not power save mode on
+     *                         the link with the given ID
+     */
+    void SetPowerSaveMode(const std::pair<bool, uint8_t>& enableLinkIdPair);
+
+    /**
+     * \param linkId the ID of the given link
+     * \return the current Power Management mode of the STA operating on the given link
+     */
+    WifiPowerManagementMode GetPmMode(uint8_t linkId) const;
+
+    /**
+     * Set the Power Management mode of the setup links after association.
+     *
+     * \param linkId the ID of the link used to establish association
+     */
+    void SetPmModeAfterAssociation(uint8_t linkId);
+
+    /**
+     * Notify that the MPDU we sent was successfully received by the receiver
+     * (i.e. we received an Ack from the receiver).
+     *
+     * \param mpdu the MPDU that we successfully sent
+     */
+    void TxOk(Ptr<const WifiMpdu> mpdu);
+
     void NotifyChannelSwitching(uint8_t linkId) override;
 
     /**
@@ -251,6 +319,9 @@
         std::optional<Mac48Address> bssid; //!< BSSID of the AP to associate with over this link
         EventId beaconWatchdog;            //!< beacon watchdog
         Time beaconWatchdogEnd{0};         //!< beacon watchdog end
+        WifiPowerManagementMode pmMode{WIFI_PM_ACTIVE}; /**< the current PM mode, if the STA is
+                                                             associated, or the PM mode to switch
+                                                             to upon association, otherwise */
     };
 
     /**
@@ -413,7 +484,7 @@
      * \param linkId the ID of the link for which the request is made
      * \return SupportedRates all rates that we support
      */
-    SupportedRates GetSupportedRates(uint8_t linkId) const;
+    AllSupportedRates GetSupportedRates(uint8_t linkId) const;
     /**
      * Return the Multi-Link Element to include in the management frames transmitted
      * on the given link
@@ -429,34 +500,47 @@
      * \param value the new state
      */
     void SetState(MacState value);
+
     /**
-     * Set the EDCA parameters.
+     * EDCA Parameters
+     */
+    struct EdcaParams
+    {
+        AcIndex ac;     //!< the access category
+        uint32_t cwMin; //!< the minimum contention window size
+        uint32_t cwMax; //!< the maximum contention window size
+        uint8_t aifsn;  //!< the number of slots that make up an AIFS
+        Time txopLimit; //!< the TXOP limit
+    };
+
+    /**
+     * Set the EDCA parameters for the given link.
      *
-     * \param ac the access class
-     * \param cwMin the minimum contention window size
-     * \param cwMax the maximum contention window size
-     * \param aifsn the number of slots that make up an AIFS
-     * \param txopLimit the TXOP limit
-     */
-    void SetEdcaParameters(AcIndex ac,
-                           uint32_t cwMin,
-                           uint32_t cwMax,
-                           uint8_t aifsn,
-                           Time txopLimit);
-    /**
-     * Set the MU EDCA parameters.
-     *
-     * \param ac the Access Category
-     * \param cwMin the minimum contention window size
-     * \param cwMax the maximum contention window size
-     * \param aifsn the number of slots that make up an AIFS
-     * \param muEdcaTimer the MU EDCA timer
-     */
-    void SetMuEdcaParameters(AcIndex ac,
-                             uint16_t cwMin,
-                             uint16_t cwMax,
-                             uint8_t aifsn,
-                             Time muEdcaTimer);
+     * \param params the EDCA parameters
+     * \param linkId the ID of the given link
+     */
+    void SetEdcaParameters(const EdcaParams& params, uint8_t linkId);
+
+    /**
+     * MU EDCA Parameters
+     */
+    struct MuEdcaParams
+    {
+        AcIndex ac;       //!< the access category
+        uint32_t cwMin;   //!< the minimum contention window size
+        uint32_t cwMax;   //!< the maximum contention window size
+        uint8_t aifsn;    //!< the number of slots that make up an AIFS
+        Time muEdcaTimer; //!< the MU EDCA timer
+    };
+
+    /**
+     * Set the MU EDCA parameters for the given link.
+     *
+     * \param params the MU EDCA parameters
+     * \param linkId the ID of the given link
+     */
+    void SetMuEdcaParameters(const MuEdcaParams& params, uint8_t linkId);
+
     /**
      * Return the Capability information for the given link.
      *
@@ -485,6 +569,7 @@
     MacState m_state;                       ///< MAC state
     uint16_t m_aid;                         ///< Association AID
     Ptr<WifiAssocManager> m_assocManager;   ///< Association Manager
+    Ptr<EmlsrManager> m_emlsrManager;       ///< EMLSR Manager
     Time m_waitBeaconTimeout;               ///< wait beacon timeout
     Time m_probeRequestTimeout;             ///< probe request timeout
     Time m_assocRequestTimeout;             ///< association request timeout
@@ -493,6 +578,7 @@
     bool m_activeProbing;                   ///< active probing
     Ptr<RandomVariableStream> m_probeDelay; ///< RandomVariable used to randomize the time
                                             ///< of the first Probe Response on each channel
+    Time m_pmModeSwitchTimeout;             ///< PM mode switch timeout
 
     TracedCallback<Mac48Address> m_assocLogger;             ///< association logger
     TracedCallback<uint8_t, Mac48Address> m_setupCompleted; ///< link setup completed logger
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/supported-rates.cc ns-3.39/src/wifi/model/supported-rates.cc
--- ns-3.38/src/wifi/model/supported-rates.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/supported-rates.cc	2023-07-05 14:23:48.121428500 -0700
@@ -32,62 +32,81 @@
 #define BSS_MEMBERSHIP_SELECTOR_EHT_PHY 121 // TODO not defined yet as of 802.11be D1.4
 
 SupportedRates::SupportedRates()
-    : extended(this),
-      m_nRates(0)
 {
     NS_LOG_FUNCTION(this);
 }
 
-SupportedRates::SupportedRates(const SupportedRates& rates)
+void
+SupportedRates::Print(std::ostream& os) const
 {
-    NS_LOG_FUNCTION(this);
-    m_nRates = rates.m_nRates;
-    memcpy(m_rates, rates.m_rates, MAX_SUPPORTED_RATES);
-    // reset the back pointer to this object
-    extended = ExtendedSupportedRatesIE(this);
+    os << "rates=[";
+    for (std::size_t i = 0; i < m_rates.size(); i++)
+    {
+        if ((m_rates[i] & 0x80) > 0)
+        {
+            os << "*";
+        }
+        os << GetRate(i) / 1000000 << "mbs";
+        if (i < m_rates.size() - 1)
+        {
+            os << " ";
+        }
+    }
+    os << "]";
 }
 
-SupportedRates&
-SupportedRates::operator=(const SupportedRates& rates)
-{
-    this->m_nRates = rates.m_nRates;
-    memcpy(this->m_rates, rates.m_rates, MAX_SUPPORTED_RATES);
-    // reset the back pointer to this object
-    this->extended = ExtendedSupportedRatesIE(this);
-    return (*this);
+bool
+AllSupportedRates::IsBasicRate(uint64_t bs) const
+{
+    NS_LOG_FUNCTION(this << bs);
+    uint8_t rate = static_cast<uint8_t>(bs / 500000) | 0x80;
+    return std::find(rates.m_rates.cbegin(), rates.m_rates.cend(), rate) != rates.m_rates.cend() ||
+           (extendedRates &&
+            std::find(extendedRates->m_rates.cbegin(), extendedRates->m_rates.cend(), rate) !=
+                extendedRates->m_rates.cend());
 }
 
 void
-SupportedRates::AddSupportedRate(uint64_t bs)
+AllSupportedRates::AddSupportedRate(uint64_t bs)
 {
     NS_LOG_FUNCTION(this << bs);
     NS_ASSERT_MSG(IsBssMembershipSelectorRate(bs) == false, "Invalid rate");
-    NS_ASSERT(m_nRates < MAX_SUPPORTED_RATES);
     if (IsSupportedRate(bs))
     {
         return;
     }
-    m_rates[m_nRates] = static_cast<uint8_t>(bs / 500000);
-    m_nRates++;
-    NS_LOG_DEBUG("add rate=" << bs << ", n rates=" << +m_nRates);
+    if (rates.m_rates.size() < 8)
+    {
+        rates.m_rates.emplace_back(static_cast<uint8_t>(bs / 500000));
+    }
+    else
+    {
+        if (!extendedRates)
+        {
+            extendedRates.emplace();
+        }
+        extendedRates->m_rates.emplace_back(static_cast<uint8_t>(bs / 500000));
+    }
+    NS_LOG_DEBUG("add rate=" << bs << ", n rates=" << +GetNRates());
 }
 
 void
-SupportedRates::SetBasicRate(uint64_t bs)
+AllSupportedRates::SetBasicRate(uint64_t bs)
 {
     NS_LOG_FUNCTION(this << bs);
     NS_ASSERT_MSG(IsBssMembershipSelectorRate(bs) == false, "Invalid rate");
     uint8_t rate = static_cast<uint8_t>(bs / 500000);
-    for (uint8_t i = 0; i < m_nRates; i++)
+    for (uint8_t i = 0; i < GetNRates(); i++)
     {
-        if ((rate | 0x80) == m_rates[i])
+        auto& currRate = i < 8 ? rates.m_rates[i] : extendedRates->m_rates[i - 8];
+        if ((rate | 0x80) == currRate)
         {
             return;
         }
-        if (rate == m_rates[i])
+        if (rate == currRate)
         {
-            NS_LOG_DEBUG("set basic rate=" << bs << ", n rates=" << +m_nRates);
-            m_rates[i] |= 0x80;
+            NS_LOG_DEBUG("set basic rate=" << bs << ", n rates=" << +GetNRates());
+            currRate |= 0x80;
             return;
         }
     }
@@ -96,73 +115,84 @@
 }
 
 void
-SupportedRates::AddBssMembershipSelectorRate(uint64_t bs)
+AllSupportedRates::AddBssMembershipSelectorRate(uint64_t bs)
 {
     NS_LOG_FUNCTION(this << bs);
     NS_ASSERT_MSG(bs == BSS_MEMBERSHIP_SELECTOR_HT_PHY || bs == BSS_MEMBERSHIP_SELECTOR_VHT_PHY ||
                       bs == BSS_MEMBERSHIP_SELECTOR_HE_PHY || bs == BSS_MEMBERSHIP_SELECTOR_EHT_PHY,
                   "Value " << bs << " not a BSS Membership Selector");
     uint8_t rate = static_cast<uint8_t>(bs / 500000);
-    for (uint8_t i = 0; i < m_nRates; i++)
+    for (std::size_t i = 0; i < rates.m_rates.size(); i++)
     {
-        if (rate == m_rates[i])
+        if (rate == rates.m_rates[i])
         {
             return;
         }
     }
-    m_rates[m_nRates] = rate;
-    NS_LOG_DEBUG("add BSS membership selector rate " << bs << " as rate " << +rate);
-    m_nRates++;
-}
-
-bool
-SupportedRates::IsBasicRate(uint64_t bs) const
-{
-    NS_LOG_FUNCTION(this << bs);
-    uint8_t rate = static_cast<uint8_t>(bs / 500000) | 0x80;
-    for (uint8_t i = 0; i < m_nRates; i++)
+    if (extendedRates)
     {
-        if (rate == m_rates[i])
+        for (std::size_t i = 0; i < extendedRates->m_rates.size(); i++)
         {
-            return true;
+            if (rate == extendedRates->m_rates[i])
+            {
+                return;
+            }
         }
     }
-    return false;
+    if (rates.m_rates.size() < 8)
+    {
+        rates.m_rates.emplace_back(rate);
+    }
+    else
+    {
+        if (!extendedRates)
+        {
+            extendedRates.emplace();
+        }
+        extendedRates->m_rates.emplace_back(rate);
+    }
+    NS_LOG_DEBUG("add BSS membership selector rate " << bs << " as rate " << +rate);
 }
 
 bool
-SupportedRates::IsSupportedRate(uint64_t bs) const
+AllSupportedRates::IsSupportedRate(uint64_t bs) const
 {
     NS_LOG_FUNCTION(this << bs);
     uint8_t rate = static_cast<uint8_t>(bs / 500000);
-    for (uint8_t i = 0; i < m_nRates; i++)
+    for (std::size_t i = 0; i < rates.m_rates.size(); i++)
     {
-        if (rate == m_rates[i] || (rate | 0x80) == m_rates[i])
+        if (rate == rates.m_rates[i] || (rate | 0x80) == rates.m_rates[i])
         {
             return true;
         }
     }
+    if (extendedRates)
+    {
+        for (std::size_t i = 0; i < extendedRates->m_rates.size(); i++)
+        {
+            if (rate == extendedRates->m_rates[i] || (rate | 0x80) == extendedRates->m_rates[i])
+            {
+                return true;
+            }
+        }
+    }
     return false;
 }
 
 bool
-SupportedRates::IsBssMembershipSelectorRate(uint64_t bs) const
+AllSupportedRates::IsBssMembershipSelectorRate(uint64_t bs) const
 {
     NS_LOG_FUNCTION(this << bs);
-    if ((bs & 0x7f) == BSS_MEMBERSHIP_SELECTOR_HT_PHY ||
-        (bs & 0x7f) == BSS_MEMBERSHIP_SELECTOR_VHT_PHY ||
-        (bs & 0x7f) == BSS_MEMBERSHIP_SELECTOR_HE_PHY ||
-        (bs & 0x7f) == BSS_MEMBERSHIP_SELECTOR_EHT_PHY)
-    {
-        return true;
-    }
-    return false;
+    return (bs & 0x7f) == BSS_MEMBERSHIP_SELECTOR_HT_PHY ||
+           (bs & 0x7f) == BSS_MEMBERSHIP_SELECTOR_VHT_PHY ||
+           (bs & 0x7f) == BSS_MEMBERSHIP_SELECTOR_HE_PHY ||
+           (bs & 0x7f) == BSS_MEMBERSHIP_SELECTOR_EHT_PHY;
 }
 
 uint8_t
-SupportedRates::GetNRates() const
+AllSupportedRates::GetNRates() const
 {
-    return m_nRates;
+    return rates.m_rates.size() + (extendedRates ? extendedRates->m_rates.size() : 0);
 }
 
 uint32_t
@@ -180,37 +210,27 @@
 uint16_t
 SupportedRates::GetInformationFieldSize() const
 {
-    // The Supported Rates Information Element contains only the first 8
-    // supported rates - the remainder appear in the Extended Supported
-    // Rates Information Element.
-    return m_nRates > 8 ? 8 : m_nRates;
+    return m_rates.size();
 }
 
 void
 SupportedRates::SerializeInformationField(Buffer::Iterator start) const
 {
-    // The Supported Rates Information Element contains only the first 8
-    // supported rates - the remainder appear in the Extended Supported
-    // Rates Information Element.
-    start.Write(m_rates, m_nRates > 8 ? 8 : m_nRates);
+    for (const uint8_t rate : m_rates)
+    {
+        start.WriteU8(rate);
+    }
 }
 
 uint16_t
 SupportedRates::DeserializeInformationField(Buffer::Iterator start, uint16_t length)
 {
     NS_ASSERT(length <= 8);
-    m_nRates = length;
-    start.Read(m_rates, m_nRates);
-    return m_nRates;
-}
-
-ExtendedSupportedRatesIE::ExtendedSupportedRatesIE()
-{
-}
-
-ExtendedSupportedRatesIE::ExtendedSupportedRatesIE(SupportedRates* sr)
-{
-    m_supportedRates = sr;
+    for (uint16_t i = 0; i < length; i++)
+    {
+        m_rates.push_back(start.ReadU8());
+    }
+    return length;
 }
 
 WifiInformationElementId
@@ -219,64 +239,4 @@
     return IE_EXTENDED_SUPPORTED_RATES;
 }
 
-void
-ExtendedSupportedRatesIE::SetSupportedRates(SupportedRates* sr)
-{
-    m_supportedRates = sr;
-}
-
-uint16_t
-ExtendedSupportedRatesIE::GetInformationFieldSize() const
-{
-    // If there are 8 or fewer rates then we don't need an Extended Supported
-    // Rates, so if this function is invoked in that case then it indicates a
-    // programming error. Hence we have an assertion on that condition.
-    NS_ASSERT(m_supportedRates->m_nRates > 8);
-
-    // The number of rates we have beyond the initial 8 is the size of
-    // the information field.
-    return (m_supportedRates->m_nRates - 8);
-}
-
-void
-ExtendedSupportedRatesIE::SerializeInformationField(Buffer::Iterator start) const
-{
-    // If there are 8 or fewer rates then there should be no Extended
-    // Supported Rates Information Element at all so being here would
-    // seemingly indicate a programming error.
-    NS_ASSERT(m_supportedRates->m_nRates > 8);
-    start.Write(m_supportedRates->m_rates + 8, m_supportedRates->m_nRates - 8);
-}
-
-uint16_t
-ExtendedSupportedRatesIE::DeserializeInformationField(Buffer::Iterator start, uint16_t length)
-{
-    NS_ASSERT(length > 0);
-    NS_ASSERT(m_supportedRates->m_nRates + length <= SupportedRates::MAX_SUPPORTED_RATES);
-    start.Read(m_supportedRates->m_rates + m_supportedRates->m_nRates, length);
-    m_supportedRates->m_nRates += length;
-    return length;
-}
-
-std::ostream&
-operator<<(std::ostream& os, const SupportedRates& rates)
-{
-    os << "[";
-    for (uint8_t i = 0; i < rates.GetNRates(); i++)
-    {
-        uint32_t rate = rates.GetRate(i);
-        if (rates.IsBasicRate(rate))
-        {
-            os << "*";
-        }
-        os << rate / 1000000 << "mbs";
-        if (i < rates.GetNRates() - 1)
-        {
-            os << " ";
-        }
-    }
-    os << "]";
-    return os;
-}
-
 } // namespace ns3
